//
// Created by zoe on 12/19/22.
//

#ifndef HOST_CENTRAL_MAST_NTPMANAGER_H
#define HOST_CENTRAL_MAST_NTPMANAGER_H

#define TINY_GSM_MODEM_SIM7000

#include "Definitions.h"
#include "ESP32Time.h"
#include "NTPException.hpp"
#include "StringToTimeConversionException.hpp"
#include <TinyGsmClientSIM7000.h>
#include <iomanip>
#include <string>

class NTPManager {
  public:
    explicit NTPManager(TinyGsmSim7000 &modem);

  private:
    int timeZone = 0;

    // I would like this to be a const reference but the functions used by the modem are not const
    TinyGsmSim7000 &modem;

    // convert time to unix epoch seconds
    static time_t timeToUnixEpochSeconds(const std::string &time, const std::string &format = "%y/%m/%d,%T+00");

    void synchronizeNTPWithModem(const std::string &ntpServer);
    void tryNtpServerSync(const std::string &backupNtpServer, std::vector<std::string> &ntpServers);

  public:
    // sync ntp
    void syncNTP(const std::string &ntpServer, const std::string &backupNtpServer);

    // write modem time to rtc
    void writeModemTimeToRTC();
};

#endif // HOST_CENTRAL_MAST_NTPMANAGER_H