//
// Created by zoe on 1/9/23.
//

#ifndef HOST_CENTRAL_MAST_REQUESTINFORMATION_H
#define HOST_CENTRAL_MAST_REQUESTINFORMATION_H

#include <Arduino.h>
#include <Definitions.h>
#include <map>

enum RequestMethod {
    GET,
    POST,
};

struct RequestInformation {
    RequestMethod method;
    std::map<String, String> headers;
    int port;
    String host;
    String path;
    String body;

    RequestInformation(const RequestMethod &method, const String &host, const int &port, const String &path,
                       const String &body, const std::map<String, String> &headers) {
        this->method = method;
        this->port = port;
        this->headers = headers;
        this->host = host;
        this->path = path;
        this->body = body;
    }

    String buildRequest() {
        String methodString = method == RequestMethod::GET ? "GET" : "POST";
        String request = "";
        request += methodString + " " + path + " HTTP/1.1\r\n";
        request += "Host: " + host + "\r\n";
        request += "User-Agent: ESP32-Host\r\n";
        for (auto &header : headers) {
            request += header.first + ": " + header.second + "\r\n";
        }
        //        request += "Authorization: Token " + INFLUXDB_TOKEN + "\r\n";
        request += "Content-Length: " + String(body.length()) + "\r\n";
        if (body.length() > 0) {
            request += "\r\n";
            request += body;
        }
        return request;
    }
};

#endif // HOST_CENTRAL_MAST_REQUESTINFORMATION_H
