//
// Created by cynthya on 1/5/23.
//

#ifndef HOST_CENTRAL_MAST_RESENDMANAGER_H
#define HOST_CENTRAL_MAST_RESENDMANAGER_H

#include "ResendPointType.h"
#include "SD.h"
#include "Utilities.h"
#include <Arduino.h>
#include <cstdio>

class ResendManager {
  public:
    // File name (as uint) of the next file to be re-send (i.e. a counter of files to be resend). Max value is
    // 4'294'967'295

    void storeForResend(const String &messageToBeSend);
    // I am making this an optional since i want to avoid creating a 'hasNextToBeResend' method since that would require
    // another fs operation. If this method returns std::nullopt, it means that there is no file to be resend.
    std::optional<ResendPointType> loadNextToBeResendMessage();
    void deleteResendMessage(const String &filename);

    void init();

  private:
    const String resendDirectoryPath = "/resend";
    uint nextResendFileId = 0;
    void incrementCount() { nextResendFileId++; }
    void createResendDirectory() const;
    uint getLastResendFileId() const;
};

#endif // HOST_CENTRAL_MAST_RESENDMANAGER_H
